## org.apache.mahout.math
Class DenseMatrix

    java.lang.Object
      org.apache.mahout.math.AbstractMatrix
          org.apache.mahout.math.DenseMatrix

All Implemented Interfaces:
  Cloneable, Iterable<MatrixSlice>, Matrix, VectorIterable

    public class DenseMatrix

extends AbstractMatrix

Matrix of doubles implemented using a 2-d array

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.mahout.math.AbstractMatrix
`AbstractMatrix.TransposeViewVector`

Field Summary

Fields inherited from class org.apache.mahout.math.AbstractMatrix
`COL, columnLabelBindings, columns, ROW, rowLabelBindings, rows`

Constructor Summary
`DenseMatrix(double[][] values)` Construct a matrix from the given values
`DenseMatrix(double[][] values, boolean shallowCopy)` Construct a matrix from the given values
`DenseMatrix(int rows, int columns)` Constructs an empty matrix of the given size.

Method Summary
`Matrix` `assign(DenseMatrix matrix)`
`Matrix` `assign(double value)` Assign the value to all elements of the receiver
`Matrix` `assignColumn(int column, Vector other)` Assign the other vector values to the column of the receiver
`Matrix` `assignRow(int row, Vector other)` Assign the other vector values to the row of the receiver
`Matrix` `clone()` Return a copy of the recipient
`double` `getQuick(int row, int column)` Return the value at the given indexes, without checking bounds
`Matrix` `like()` Return an empty matrix of the same underlying class as the receiver
`Matrix` `like(int rows, int columns)` Returns an empty matrix of the same underlying class as the receiver and of the specified size.
`void` `setQuick(int row, int column, double value)` Set the value at the given index, without checking bounds
`Matrix` `viewPart(int[] offset, int[] size)` Return a view into part of a matrix.
`Matrix` `viewPart(int rowOffset, int rowsRequested, int columnOffset, int columnsRequested)` Return a view into part of a matrix.
`Vector` `viewRow(int row)` Returns a view of a row.

Methods inherited from class org.apache.mahout.math.AbstractMatrix

`aggregate, aggregateColumns, aggregateRows, asFormatString, assign, assign, assign, assign, columnSize, determinant, divide, get, get, getColumnLabelBindings, getNumNondefaultElements, getRowLabelBindings, iterateAll, iterator, minus, numCols, numRows, numSlices, plus, plus, rowSize, set, set, set, set, set, set, setColumnLabelBindings, setRowLabelBindings, times, times, times, timesSquared, toString, transpose, viewColumn, viewDiagonal, zSum`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DenseMatrix

    public DenseMatrix(double[][] values)

  Construct a matrix from the given values

  Parameters:
    `values` - a double[][]

### DenseMatrix

    public DenseMatrix(double[][] values,
                       boolean shallowCopy)

  Construct a matrix from the given values

  Parameters:
    `values` - a double[][]
    `shallowCopy` - directly use the supplied array?

### DenseMatrix

    public DenseMatrix(int rows,
                       int columns)

  Constructs an empty matrix of the given size.

  Parameters:
    `rows` - The number of rows in the result.
    `columns` - The number of columns in the result.

Method Detail

### clone

    public Matrix clone()

  Description copied from interface: `Matrix`
  Return a copy of the recipient

  Specified by:
    `clone` in interface `Matrix`
  Overrides:
    `clone` in class `AbstractMatrix`
  Returns:
    a new Matrix

### getQuick

    public double getQuick(int row,
                           int column)

  Description copied from interface: `Matrix`
  Return the value at the given indexes, without checking bounds

  Parameters:
    `row` - an int row index
    `column` - an int column index
  Returns:
    the double at the index

### like

    public Matrix like()

  Description copied from interface: `Matrix`
  Return an empty matrix of the same underlying class as the receiver

  Returns:
    a Matrix

### like

    public Matrix like(int rows,
                       int columns)

  Description copied from interface: `Matrix`
  Returns an empty matrix of the same underlying class as the receiver and of the specified size.

  Parameters:
    `rows` - the int number of rows
    `columns` - the int number of columns

### setQuick

    public void setQuick(int row,
                         int column,
                         double value)

  Description copied from interface: `Matrix`
  Set the value at the given index, without checking bounds

  Parameters:
    `row` - an int row index into the receiver
    `column` - an int column index into the receiver
    `value` - a double value to set

### viewPart

    public Matrix viewPart(int[] offset,
                           int[] size)

  Description copied from interface: `Matrix`
  Return a view into part of a matrix. Changes to the view will change the original matrix.

  Specified by:
    `viewPart` in interface `Matrix`
  Overrides:
    `viewPart` in class `AbstractMatrix`
  Parameters:
    `offset` - an int[2] offset into the receiver
    `size` - the int[2] size of the desired result
  Returns:
    a matrix that shares storage with part of the original matrix.

### viewPart

    public Matrix viewPart(int rowOffset,
                           int rowsRequested,
                           int columnOffset,
                           int columnsRequested)

  Description copied from interface: `Matrix`
  Return a view into part of a matrix. Changes to the view will change the original matrix.

  Specified by:
    `viewPart` in interface `Matrix`
  Overrides:
    `viewPart` in class `AbstractMatrix`
  Parameters:
    `rowOffset` - The first row of the view
    `rowsRequested` - The number of rows in the view
    `columnOffset` - The first column in the view
    `columnsRequested` - The number of columns in the view
  Returns:
    a matrix that shares storage with part of the original matrix.

### assign

    public Matrix assign(double value)

  Description copied from interface: `Matrix`
  Assign the value to all elements of the receiver

  Specified by:
    `assign` in interface `Matrix`
  Overrides:
    `assign` in class `AbstractMatrix`
  Parameters:
    `value` - a double value
  Returns:
    the modified receiver

### assign

    public Matrix assign(DenseMatrix matrix)

### assignColumn

    public Matrix assignColumn(int column,
                               Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the column of the receiver

  Parameters:
    `column` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### assignRow

    public Matrix assignRow(int row,
                            Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the row of the receiver

  Parameters:
    `row` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### viewRow

    public Vector viewRow(int row)

  Description copied from class: `AbstractMatrix`
  Returns a view of a row. Changes to the view will affect the original.

  Specified by:
    `viewRow` in interface `Matrix`
  Overrides:
    `viewRow` in class `AbstractMatrix`
  Parameters:
    `row` - Which row to return.
  Returns:
    A vector that references the desired row.

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.